<template>
  <section class="section" id="billing">
    <h1 class="title is-5 billing__title">Billing</h1>
    <section class="section billing__usage">
      <div class="columns">
        <div class="column">
          <div class="dropdown is-hoverable">
            <div class="dropdown-trigger">
              <button class="button" aria-haspopup="true" aria-controls="dropdown-menu">
                <span>Date Range</span>
                <span class="icon is-small">
                  <i class="fas fa-angle-down" aria-hidden="true"></i>
                </span>
              </button>
            </div>
            <div class="dropdown-menu">
              <div class="dropdown-content">
                <a
                  class="dropdown-item"
                  v-on:click="change_date_range(d)"
                  v-for="d in date_ranges"
                  :key="'usage'+d"
                  :id="'usage'+ d"
                  :class="{'is-active': current_day_range === d}"
                >{{ d }} days</a>
              </div>
            </div>
          </div>
        </div>
      </div>
      <div v-if="active_project" class="columns is-multiline">
        <div class="column is-full-mobile is-full-desktop is-full-fullhd">
          <div class="card">
            <div class="card-content">
              <UsageGraph :height="100" :chart-data="dataCollection" />
            </div>
          </div>
        </div>
      </div>
      <div v-else class="container">
        <div class="hero">
          <div class="hero-body">
            <div class="container has-text-centered">
              <h1 class="title is-4">No instances available</h1>
              <h2 class="subtitle is-6">
                Why not create one from the
                <router-link :to="{name: 'service-catalog'}">Service Catalog?</router-link>
              </h2>
            </div>
          </div>
        </div>
      </div>
    </section>
    <section class="section is-hidden-mobile billing__history"></section>
  </section>
</template>

<script lang="ts">
import { Component, Vue, Prop } from "vue-property-decorator";
import BillingHistory from "@/components/BillingHistory.vue";
import UsageGraph from "@/components/UsageGraph.vue";
import arbaloExtensions from "@/services/arbalo_extensions/service";
import { Project } from "../services/arbalo_extensions/projects";

@Component({ components: { UsageGraph, BillingHistory } })
export default class ProjectBilling extends Vue {
  /* Attributes */
  current_day = 30;

  private dataCollection = {};

  /* Getters */
  get date_ranges(): number[] {
    return [30, 90, 120];
  }

  get current_day_range(): number {
    return this.current_day;
  }

  get usage_dates(): string[] {
    return this.$store.getters["project/getUsageDates"];
  }

  get usage_values(): number[] {
    return this.$store.getters["project/getUsageValues"];
  }

  get active_project() {
    return this.$store.state.activeProject;
  }

  private refresh_data_collection() {
    this.dataCollection = {
      labels: this.usage_dates,
      datasets: [
        {
          label: `Project usage`,
          data: this.usage_values,
          fill: true,
          borderColor: "#7BD",
          backgroundColor: "#39D"
        }
      ]
    };
    window.setTimeout(this.refresh_data_collection, 3000);
  }

  async update_usage_data() {
    await this.$store.dispatch("project/fetchUsageForActiveProject", {
      numberOfDays: this.current_day
    });
    this.dataCollection = {
      labels: this.usage_dates,
      datasets: [
        {
          label: `Project usage`,
          data: this.usage_values,
          fill: true,
          borderColor: "#7BD",
          backgroundColor: "#39D"
        }
      ]
    };
  }

  /* Methods */
  async change_date_range(days: number) {
    if (this.current_day === days) {
      // don't do anything if it's the same date range
      return;
    }
    this.current_day = days;
    this.update_usage_data();
  }

  private async mounted() {
    await this.update_usage_data();
    this.$store.dispatch("project/pollLatestUsage");
    this.refresh_data_collection();
  }
}
</script>

<style lang="scss" scoped>
.project-usage {
  max-height: 100px;
}
</style>
